org.apache.uima.jcas.cas

## Class FSArray

- java.lang.Object
- - org.apache.uima.cas.impl.FeatureStructureImpl
  - - org.apache.uima.jcas.cas.TOP
    - - org.apache.uima.jcas.cas.FSArray

- All Implemented Interfaces:
    Cloneable, Iterable<FeatureStructure>, ArrayFS, CommonArrayFS, FeatureStructure

      public final class FSArray
      extends TOP
      implements Iterable<FeatureStructure>, ArrayFS

  Java Class model for Cas FSArray type

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `type`
    `static int` | `typeIndexID` each cover class when loaded sets an index.

    - ### Fields inherited from class org.apache.uima.jcas.cas.TOP

      `addr, jcasType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FSArray(int addr, TOP_Type type)`
    `FSArray(JCas jcas, int length)` Make a new FSArray of given size

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `copyFromArray(FeatureStructure[] src, int srcOffset, int destOffset, int length)` Copy the contents of an external array into this array.
    `void` | `copyFromArray(String[] src, int srcOffset, int destOffset, int length)` Not supported, will throw UnsupportedOperationException
    `void` | `copyToArray(int srcOffset, FeatureStructure[] dest, int destOffset, int length)` Copy the contents of the array from `start` to `end` to the destination `destArray` with destination offset `destOffset`.
    `void` | `copyToArray(int srcOffset, String[] dest, int destOffset, int length)` Copies an array of Feature Structures to an Array of Strings.
    `FeatureStructure` | `get(int i)` return the indexed value from the corresponding Cas FSArray as a Java Model object.
    `int` | `getTypeIndexID()` used to obtain reference to the _Type instance
    `Iterator<FeatureStructure>` | `iterator()`
    `void` | `set(int i, FeatureStructure v)` updates the Cas, setting the indexed value with the corresponding Cas FeatureStructure.
    `int` | `size()` return the size of the array.
    `FeatureStructure[]` | `toArray()` Creates a new array the this array is copied to.
    `String[]` | `toStringArray()` Creates a new string array and copies this array values into it.

    - ### Methods inherited from class org.apache.uima.jcas.cas.TOP

      `addToIndexes, addToIndexes, equals, getAddress, getCAS, getCASImpl, getLowLevelCas, hashCode, removeFromIndexes, removeFromIndexes`

    - ### Methods inherited from class org.apache.uima.cas.impl.FeatureStructureImpl

      `clone, getavoidcollisionTypeCode, getBooleanValue, getByteValue, getDoubleValue, getFeatureValue, getFeatureValueAsString, getFloatValue, getIntValue, getLongValue, getShortValue, getStringValue, getType, prettyPrint, prettyPrint, prettyPrint, setBooleanValue, setByteValue, setDoubleValue, setFeatureValue, setFeatureValueFromString, setFloatValue, setIntValue, setLongValue, setShortValue, setStringValue, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface org.apache.uima.cas.FeatureStructure

      `clone, equals, getBooleanValue, getByteValue, getCAS, getDoubleValue, getFeatureValue, getFeatureValueAsString, getFloatValue, getIntValue, getLongValue, getShortValue, getStringValue, getType, hashCode, setBooleanValue, setByteValue, setDoubleValue, setFeatureValue, setFeatureValueFromString, setFloatValue, setIntValue, setLongValue, setShortValue, setStringValue`

- - ### Field Detail

    - #### typeIndexID

          public static final int typeIndexID

      each cover class when loaded sets an index. used in the JCas typeArray to go from the cover class or class instance to the corresponding instance of the _Type class

    - #### type

          public static final int type

  - ### Constructor Detail

    - #### FSArray

          public FSArray(int addr,
                         TOP_Type type)

    - #### FSArray

          public FSArray(JCas jcas,
                         int length)

      Make a new FSArray of given size
      Parameters:
        `jcas` - The JCas
        `length` - The number of elements in the new array

  - ### Method Detail

    - #### getTypeIndexID

          public int getTypeIndexID()

      used to obtain reference to the _Type instance
      Overrides:
        `getTypeIndexID` in class `TOP`
      Returns:
        the type array index

    - #### get

          public FeatureStructure get(int i)

      return the indexed value from the corresponding Cas FSArray as a Java Model object.
      Specified by:
        `get` in interface `ArrayFS`
      Parameters:
        `i` - index
      Returns:
        The i-th feature structure.

    - #### set

          public void set(int i,
                          FeatureStructure v)

      updates the Cas, setting the indexed value with the corresponding Cas FeatureStructure.
      Specified by:
        `set` in interface `ArrayFS`
      Parameters:
        `i` - The index.
        `v` - The value.

    - #### size

          public int size()

      return the size of the array.
      Specified by:
        `size` in interface `ArrayFS`
      Specified by:
        `size` in interface `CommonArrayFS`
      Returns:
        The size of the array.

    - #### copyFromArray

          public void copyFromArray(FeatureStructure[] src,
                                    int srcOffset,
                                    int destOffset,
                                    int length)

      Description copied from interface: `ArrayFS`
      Copy the contents of an external array into this array.
      Specified by:
        `copyFromArray` in interface `ArrayFS`
      Parameters:
        `src` - The source array.
        `srcOffset` - Where to start copying in the source array.
        `destOffset` - Where to start copying to in the destination array.
        `length` - The number of elements to copy.
      See Also:
        `ArrayFS.copyFromArray(FeatureStructure[], int, int, int)`

    - #### copyToArray

          public void copyToArray(int srcOffset,
                                  FeatureStructure[] dest,
                                  int destOffset,
                                  int length)

      Description copied from interface: `ArrayFS`
      Copy the contents of the array from `start` to `end` to the destination `destArray` with destination offset `destOffset`.
      Specified by:
        `copyToArray` in interface `ArrayFS`
      Parameters:
        `srcOffset` - The index of the first element to copy.
        `dest` - The array to copy to.
        `destOffset` - Where to start copying into `dest`.
        `length` - The number of elements to copy.
      See Also:
        `ArrayFS.copyToArray(int, FeatureStructure[], int, int)`

    - #### toArray

          public FeatureStructure[] toArray()

      Description copied from interface: `ArrayFS`
      Creates a new array the this array is copied to.
      Specified by:
        `toArray` in interface `ArrayFS`
      Returns:
        A Java array copy of this FS array.
      See Also:
        `ArrayFS.toArray()`

    - #### copyFromArray

          public void copyFromArray(String[] src,
                                    int srcOffset,
                                    int destOffset,
                                    int length)

      Not supported, will throw UnsupportedOperationException
      Specified by:
        `copyFromArray` in interface `CommonArrayFS`
      Parameters:
        `src` - The source array.
        `srcOffset` - Where to start copying in the source array.
        `destOffset` - Where to start copying to in the destination array.
        `length` - The number of elements to copy.

    - #### copyToArray

          public void copyToArray(int srcOffset,
                                  String[] dest,
                                  int destOffset,
                                  int length)

      Copies an array of Feature Structures to an Array of Strings. The strings are the "toString()" representation of the feature structures, which are probably something that looks like FeatureStructure@123456
      Specified by:
        `copyToArray` in interface `CommonArrayFS`
      Parameters:
        `srcOffset` - The index of the first element to copy.
        `dest` - The array to copy to.
        `destOffset` - Where to start copying into `dest`.
        `length` - The number of elements to copy.
      Throws:
        `ArrayIndexOutOfBoundsException` - If `srcOffset < 0` or `length > size()` or `destOffset + length > destArray.length`.

    - #### toStringArray

          public String[] toStringArray()

      Description copied from interface: `CommonArrayFS`
      Creates a new string array and copies this array values into it.
      Specified by:
        `toStringArray` in interface `CommonArrayFS`
      Returns:
        A Java array copy of this array.

    - #### iterator

          public Iterator<FeatureStructure> iterator()

      Specified by:
        `iterator` in interface `Iterable<FeatureStructure>`

Copyright © 2006–2017 The Apache Software Foundation. All rights reserved.